/******************************************************************
file name:def.h

******************************************************************/
#ifndef _DEF_H
#define _DEF_H

/////////////////////////////////////////
struct bitRegister{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};
//////////////////////////////////////////
typedef unsigned char BYTE;
typedef unsigned long WORD;
typedef double DWORD;
///////////////////////////////////////////
//special port define
#define I2C_SCL 	FP13
#define I2C_SDA		FP14

#define SPI_SCS		FP23
#define SPI_SCK		FP22
#define SPI_SDI		FP20
#define SPI_SDO		FP21

////////////////////////////////////////////
//sfr define for fc2824
////////////////////////////////////////////
//=================================================
//Ĵ궨
//=================================================
sfr	R = 0x82;
sfr	Z = 0x83;
sfr	Y = 0x84;
sfr	PFLAG = 0x86;
sfr	RBANK = 0x87;
//=================================================

 sfr    TM0M    =0X90;
 sfr    TM0CL   =0X91;
 sfr    TM0CH   =0X92;
 sfr    TM0D0L  =0X93;
 sfr    TM0D0H  =0X94;
 sfr    TM0D1L  =0X95;
 sfr    TM0D1H  =0X96;
 sfr    PWM0E   =0X97;

 sfr	SPIC0	=0X98;
 sfr	SPIC1	=0X99;
 sfr	SPIBUF	=0X9A;
//=================================================

 sfr    TM1M    =0XA0;
 sfr    TM1C    =0XA1;
 sfr    TM1D0   =0XA2;
 sfr    TM1D1   =0XA3;
 sfr    TM1D2   =0XA4;
 sfr    TM1D3   =0XA5;
 sfr    PWM1E   =0XA6;

 sfr	I2CCON	=0XA8;
 sfr	I2CADD	=0XA9;
 sfr	I2CBUF	=0XAA;
//=================================================

 sfr    TM2M    =0XB0;
 sfr    TM2C    =0XB1;
 sfr    TM2D0   =0XB2;
 sfr    TM2D1   =0XB3;
 sfr    TM2D2   =0XB4;
 sfr    TM2D3   =0XB5;
 sfr    PWM2E   =0XB6;
//=================================================

 sfr    lcdadr =0x9f;
 sfr    lcddb  =0x9e;
 sfr    lcdseg =0x9d;
 sfr    lcdcom =0x9c;
 sfr    lcdcon =0x9b;
//=================================================

 sfr    E2PCON =0Xab;
 sfr    E2PDB  =0Xac;
 sfr    E2PADL =0Xad;
 sfr    E2ADH  =0Xae;
//=================================================

 sfr    TKCON=  0X88;
 sfr    TKTMD0 =0X89;
 sfr    TKTMCH =0X8B;
 sfr    TKTMCL =0X8C;
 sfr    TKTMRH =0X8D;
 sfr    TKTMRL =0X8E;
 sfr    TKTMIO =0X8F;
//=================================================

 sfr    ADM    =0XB9;
 sfr    ADB    =0XBa;
 sfr    ADR    =0XBb;
 sfr    ADT    =0XBc;
 sfr    VREFH  =0XBd;
 sfr    ADPCON =0Xbe;
 sfr	PEDGE  =0XBF;
//=================================================

 sfr    P1W    =0XC0;
 sfr	P1M    =0xC1;
 sfr	P2M    =0XC2;
 sfr	P3M    =0XC3;
 sfr    INTRQ1 =0XC6;
 sfr    INTEN1 =0XC7;

 sfr    INTRQ  =0XC8;
 sfr    INTEN  =0XC9;
 sfr	OSCM   =0xCA;
 sfr	RCADJ  =0XCB;
 sfr	WDTR   =0XCC;
 sfr    OPTION =0XCD;
 sfr	PCL    =0XCE;
 sfr	PCH    =0XCF;
//=================================================

 sfr	P1     =0XD1;
 sfr	P2     =0XD2;
 sfr	P3     =0XD3;
 sfr	T0M    =0XD8;
 sfr	T0C    =0XD9;
 sfr    OPA1CON=0XDA;
 sfr    OPA2CON=0XDB;
 sfr    P1OD   =0XDC;
 sfr    P2W    =0Xdd;
 sfr    P3W    =0XDE;
 sfr    STKP   =0XDF;
//=================================================

 sfr	P1UR=0XE1;
 sfr	P2UR=0XE2;
 sfr	P3UR=0XE3;
//=================================================

sbit	E2P_ER_HALF =0xAB:5;
sbit	E2P_BER	    =0xAB:4;
sbit	E2P_CER	    =0xAB:3;
sbit	E2P_SER		=0xAb:2;
sbit	E2P_PG		=0xAb:1;
sbit	E2P_RD		=0xAb:0;
///SPI CONTROL
sbit	SPIEN		=0x98:0;

sbit	WCOL		=0x99:1;
sbit	CSEN		=0x99:2;
sbit	MLS		    =0x99:3;
sbit	CKEG		=0x99:4;
sbit	CKPOLB		=0x99:5;
////////////////////////////////////
//I2C CONTROL---------------------
sbit	I2CEN		=0xA8:0;
sbit	I2CPU		=0xA8:1;
sbit	I2CCKP		=0xA8:2;
sbit	TXAK		=0xA8:3;
sbit	SRW		    =0xA8:4;
sbit	HBB		    =0xA8:5;
sbit	HAAS		=0xA8:6;
sbit	HCF		    =0xA8:7;
///////////////////////////////////////////////////////
//----TOUCH // sfr--------------
sbit	TKM0S0		=0x88:0;
sbit	TKM0S1		=0x88:1;
sbit	TKTMPS0		=0x88:2;
sbit	TKTMPS1		=0x88:3;
sbit	TKM0EN		=0x88:4;
sbit	TKM1EN		=0x88:5;
sbit	TKTMSC		=0x88:6;
sbit	TKEN		=0x88:7;

sbit	TKM1S0		=0x89:0;
sbit	TKM1S1		=0x89:1;
sbit	TKRDS0		=0x89:2;
sbit	TKTCEN		=0x89:3;
sbit	TKTCFS0		=0x89:4;
sbit	TKTCFS1		=0x89:5;
sbit	TKTCFS2		=0x89:6;
sbit	TKTMREN		=0x89:7;

//sbit	TKM2S0		=0x8A:0;
//sbit	TKM2S1		=0x8A:1;
//sbit	TKTMSC		=0x8A:2;
//sbit	TKTCEN		=0x8A:3;

///////////////////////////////////////////////////
//----LCD CONTROL
sbit	LCDEN		=0x9B:0;
sbit	RESL0		=0x9B:1;
sbit	RESL1		=0x9B:2;
sbit	OSCS		=0x9B:3;
sbit	LCDT0		=0x9B:4;
sbit	LCDT1		=0x9B:5;
sbit	LCDRC_EN	=0x9B:6;

///////////////////////////////////////////////////
//----OPTION CONTROL
sbit	WDTP0		=0xCD:0;
sbit	WDTP1		=0xCD:1;
sbit	WDTP2		=0xCD:2;
sbit	RTCCON		=0xCD:3;
sbit	LVDTEN		=0xCD:4;
sbit	LDOEN		=0xCD:5;
sbit	LIRC_EN		=0xCD:6;
sbit	RCADJEN		=0xCD:7;

///////////////////////////////////////////////////
///-------------ADC REGISTER-----------------------
//----ADM CONTROL
sbit	CHS0		=0xB9:0;
sbit	CHS1		=0xB9:1;
sbit	CHS2		=0xB9:2;
sbit	CHS3		=0xB9:3;
sbit	GCHS		=0xB9:4;
sbit	EOC			=0xB9:5;
sbit	ADS			=0xB9:6;
sbit	ADENB		=0xB9:7;


//----ADR CONTROL
sbit	ADCKS0		=0xBB:4;
sbit	ADCKS1		=0xBB:6;


//----ADT CONTROL
sbit	ADT_0		=0xBc:0;
sbit	ADT_1		=0xBC:1;
sbit	ADT_2		=0xBC:2;
sbit	ADT_3		=0xBC:3;
sbit	ADT_4		=0xBC:4;

sbit	adts_0		=0xBC:6;
sbit	adts_1		=0xBC:7;

//----VREFH CONTROL
sbit	VHS0		=0xBD:0;
sbit	VHS1		=0xBD:1;

sbit	EVHENB		=0xBD:7;
///////////////////////////////////////////////////
//----------timer0,1,2 register-------------------
//T0M
sbit	PWM0OE		=0x90:0;
sbit	ALOAD0		=0x90:1;
sbit	T0CKS0		=0x90:2;
sbit	T0CKS1		=0x90:3;
sbit	T0PS0		=0x90:4;
sbit	T0PS1		=0x90:5;
sbit	T0PS2		=0x90:6;
sbit	T0TR		=0x90:7;
//T1M
sbit	PWM1OE		=0xA0:0;
sbit	ALOAD1		=0xA0:1;
sbit	T1CKS0		=0xA0:2;
sbit	T1CKS1		=0xA0:3;
sbit	T1PS0		=0xA0:4;
sbit	T1PS1		=0xA0:5;
sbit	T1PS2		=0xA0:6;
sbit	T1TR		=0xA0:7;
//T0M
sbit	PWM2OE		=0xB0:0;
sbit	ALOAD2		=0xB0:1;
sbit	T2CKS0		=0xB0:2;
sbit	T2CKS1		=0xB0:3;
sbit	T2PS0		=0xB0:4;
sbit	T2PS1		=0xB0:5;
sbit	T2PS2		=0xB0:6;
sbit	T2TR		=0xB0:7;

//pwmcon0
sbit	PWM01E		=0x97:0;
sbit	PWM00HL		=0x97:1;
sbit	PWM01HL		=0x97:2;
sbit	PWM0M		=0x97:3;
sbit	PWM00OE		=0x97:4;
sbit	PWM01OE		=0x97:5;
sbit	TC0WAKE		=0x97:6;
sbit	PWM0OD		=0x97:7;
//pwmcon1
sbit	PWM11E		=0xA7:0;
sbit	PWM10HL		=0xA7:1;
sbit	PWM11HL		=0xA7:2;
sbit	PWM1M		=0xA7:3;
sbit	PWM10OE		=0xA7:4;
sbit	PWM11OE		=0xA7:5;
sbit	TC1WAKE		=0xA7:6;
sbit	PWM1OD		=0xA7:7;
//pwmcon2
sbit	PWM21E		=0xB7:0;
sbit	PWM20HL		=0xB7:1;
sbit	PWM21HL		=0xB7:2;
sbit	PWM2M		=0xB7:3;
sbit	PWM20OE		=0xB7:4;
sbit	PWM21OE		=0xB7:5;
sbit	TC2WAKE		=0xB7:6;
sbit	PWM2OD		=0xB7:7;
///////////////////////////////////////////////////////////////
//---------INTRUPT register ---------------------------
//inte
sbit	INT0IE		=0xc9:0;
sbit	INT1IE		=0xc9:1;
sbit	TM0IE		=0xc9:2;
sbit	TM1IE		=0xc9:3;
sbit	TM2IE		=0xc9:4;
sbit	RPIE		=0xc9:5;
sbit	I2CIE		=0xc9:6;
sbit	ADCIE		=0xc9:7;
//inteN1
sbit	E2PIE		=0xc7:0;
sbit	TKTMRIE		=0xc7:1;
sbit	SPIIE		=0xc7:2;
sbit	T0IE	    =0xC7:3;
sbit	OPAIE    	=0xC7:4;
//intRQ
sbit	INT0IF		=0xc8:0;
sbit	INT1IF		=0xc8:1;
sbit	TM0IF		=0xc8:2;
sbit	TM1IF		=0xc8:3;
sbit	TM2IF		=0xc8:4;
sbit	RPIF		=0xc8:5;
sbit	I2CIF		=0xc8:6;
sbit	ADCIF		=0xc8:7;
//intRQ1
sbit	E2PIF		=0xc6:0;
sbit	TKTMRIF		=0xc6:1;
sbit	SPIIF		=0xc6:2;
sbit	T0IF	    =0xC6:3;
sbit	OPAIF    	=0xC6:4;
//P1
sbit	FP17 = 0xd1:7;
sbit	FP16 = 0xd1:6;
sbit	FP15 = 0xd1:5;
sbit	FP14 = 0xd1:4;
sbit	FP13 = 0xd1:3;
sbit	FP12 = 0xd1:2;
sbit	FP11 = 0xd1:1;
sbit	FP10 = 0xd1:0;
//P2
sbit	FP25 = 0xd2:5;
sbit	FP24 = 0xd2:4;
sbit	FP23 = 0xd2:3;
sbit	FP22 = 0xd2:2;
sbit	FP21 = 0xd2:1;
sbit	FP20 = 0xd2:0;
//P3
sbit	FP37 = 0xd3:7;
sbit	FP36 = 0xd3:6;
sbit	FP35 = 0xd3:5;
sbit	FP34 = 0xd3:4;
sbit	FP33 = 0xd3:3;
sbit	FP32 = 0xd3:2;
sbit	FP31 = 0xd3:1;
sbit	FP30 = 0xd3:0;
//OSCM 
//sbit	FCPUM1 = 0xca:4;
//sbit	FCPUM0 = 0xca:3;
sbit	FCLKMD = 0xca:2;
sbit	FSTPHX = 0xca:1;
//STKP
sbit	FGIE   = 0xDF:7;

sbit	FSTKPB2= 0xDF:2;
sbit	FSTKPB1= 0xDF:1;
sbit	FSTKPB0= 0xDF:0;
/////////////////////////////////////////////////////


/////////////////////////////////////////////////////
#define HIBYTE(wval)		*(((BYTE*)(&wval))+1)
#define LWBYTE(wval)		*(((BYTE*)(&wval))+0)

#define HIWORD(wval)		*(((WORD*)(&wval))+1)
#define LWWORD(wval)		*(((WORD*)(&wval))+0)
#define SLEEPMODE __asm{SleepMode}
#define GREENMODE __asm{GreenMode}
#define SLOWMODE __asm{SLowMode}
#define SLOW2NORMAL __asm{Slow2Normal}


#endif